#include <stdlib.h>
#include <sun/audioio.h>
#include <stropts.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <signal.h>
#include "audio.hh"

Audio :: Audio(int n)
{
  pid = fork();
  const char *argv[] = { "rplayd", "-t", "600", "-c", "60", "--no-auth", "-A", "/dev/audio", "-n", "-c", "1000", "-C", rplay_conf, NULL };
  char *envp = "";
  if (pid == 0)
  {
    execve("/home/jupiter/diverse/tavlan/bin/audio/rplay/rplayd", argv, &envp);
    perror("gnurk");
    exit(1);
  }
  
  rplay_fd = rplay_open(rplay_default_host());
  
  rp = new RPLAY*[n];
  
  for (int i = 0; i < n; i++)
    rp[i] = rplay_create(RPLAY_PLAY);

  audio_info_t info;
  AUDIO_INITINFO(&info);
  int fd = open("/dev/audioctl", O_RDONLY);
  ioctl(fd, AUDIO_GETINFO, &info);
  volume = info.play.gain;

  sounds = 0;
}

Audio :: ~Audio()
{
  for (int i = sounds; i > 0; i--)
    delete rp[i];
  kill(pid, SIGTERM);
}

void Audio :: KillAudio()
{
  for (int i = sounds; i > 0; i--)
    delete rp[i];
  kill(pid, SIGTERM);
}

void Audio :: Load(int n, char *f)
{
  rplay_set(rp[n], RPLAY_INSERT, 0,
	    RPLAY_SOUND, f,
	    NULL);
  sounds++;
}

void Audio :: Play(int n)
{
  rplay(rplay_fd, rp[n]);
}

void Audio :: Volume(int n)
{
  volume = n;
  audio_info_t info;
  AUDIO_INITINFO(&info);
  int fd = open("/dev/audioctl", O_WRONLY);
  info.play.gain = volume;
  ioctl(fd, AUDIO_SETINFO, &info);
}

int Audio :: Volume()
{
  return volume;
}
