#include "bonus.hh"
#include "explosion.hh"
#include "bat.hh"
#include "ball.hh"
#include "bullet.hh"
#include "game.hh"
#include "effect.hh"

extern Explosions explo;
extern Bat bat;
extern BallContainer balls;
extern int numberOfBullets;
extern int rocket;
extern Bullets bullets;
extern Game game;
extern Effect effect;


Bonus::Bonus()
{
  type = -1;
}


Bonus::~Bonus()
{
}

void Bonus::Update()
{
  int soundnr[]={21,22,0,0,23,0,0,0,30,0,
		 26,28,0,0,29,24,0,25,27,0};
  if (type==-1)
    return;
  
  y+=speed;
  static int wi;
  static int he;
  if (type<10)
    {
      wi = BRICK_WIDTH;
      he=BRICK_HEIGHT;
    }
  else
    {
      wi=he=30;
    }

  if((y + he > bat.y && y < bat.y+bat.h) &&
     (x + wi > bat.x && x < bat.x+bat.w))
    {   
     
      if (type>9)
	{
	
	  if (game.sound==1) audio.Play(soundnr[type-10]);
	    
	  game.AddLetter(type-10);
	}
      else
	{
	
	  switch(type)
	    {
	    case 0:              // glue
	      if (game.sound==1) audio.Play(41);
	      game.score += 30;	  
	      if (game.rocket == 0)
		{
		  if (game.numberOfBullets>0)
		    {
		      bat.w = BAT_WIDTH;
		      bat.h = BAT_HEIGHT;
		      bat.size = 2;
		    }
		  game.numberOfBullets = 0;
		  bat.catchTimes = 20;
		  bat.stat = 1;
		}
	      break;
	      
	    case 1:              // bigger bat
	      if (game.sound==1) audio.Play(41);
	      game.score += 30;	  
	      if (bat.size<5)
		{
		  if (game.numberOfBullets>0)
		    {
		      bat.stat = 0;
		      bat.h = BAT_HEIGHT;
		      bat.size = 2;
		      game.numberOfBullets = 0;
		    }
		  bat.w += BAT_WIDTH;
		  bat.size++;
		  if (bat.size == 1)
		    bat.w = 32;
		  if (bat.size == 2)
		    bat.w = BAT_WIDTH;
		}
	      break;
	      
	    case 2:              // lower speed
	      if (game.sound==1) audio.Play(41);
	      game.score += 30;	  
	      balls.ChangeSpeed(-1);
	      break;
	      
	    case 3:              // get blaster
	      if (game.sound==1) audio.Play(7);
	      game.score += 30;	  
	      if (game.rocket==0)
		{
		  balls.LaunchAll();
		  bat.stat = 2;
		  bat.w = BAT_WIDTH;
		  bat.h = BAT_HEIGHT*2;
		  bat.size = 0;
		  game.numberOfBullets += 100;
		  bat.catchTimes = 0;
		}
	      break;
	      
	    case 4:              // get rocket
	      if (game.sound==1) audio.Play(7);
	      game.score += 30;	  
	      if (game.rocket==0)
		{
		  bat.stat = 0;
		  bat.w = BAT_WIDTH;
		  bat.h = BAT_HEIGHT;
		  bat.size = 2;
		  game.numberOfBullets = 0;
		  game.rocket = 1;
		  bullets.Add(bat.x+bat.w/2-5,bat.y-28,1,0);
		  bat.catchTimes = 0;
		}
	      break;
	      
	    case 5:              // get 100-bonus
	      if (game.sound==1) audio.Play(45);
	  
	      game.score += 100;
	      break;
	      
	    case 6: 
	      game.score += 30;
	      if (game.sound==1) audio.Play(13);
	  
	      game.life++;
	      effect.UpdateLife();
	      break;
	    }
	}
      type = -1;
      explo.Add(x,y);
    }
  
  if (y>(GAME_HEIGHT-3)*BRICK_HEIGHT)
    {
      type = -1;
      explo.Add(x,y);
    }
  Draw();
}



void Bonus::Draw()
{
  if (type<10)
    {
      fig++;
      if (fig>11) fig=0;
      pw_rop((Xv_opaque)pw, x, y-speed, BRICK_WIDTH, speed, 
	     PIX_SRC, poBack.pr, x,y-speed);
      pw_rop((Xv_opaque)pw, x, y, BRICK_WIDTH, BRICK_HEIGHT, 
	     PIX_SRC, poBonus.pr, type*BRICK_WIDTH,int(fig/2)*BRICK_HEIGHT);
    }
  else
    {
      pw_rop((Xv_opaque)pw, x, y-speed,30, speed, 
	     PIX_SRC, poBack.pr, x,y-speed);
      pw_rop((Xv_opaque)pw, x, y, 30,30, 
	     PIX_SRC, poLetter.pr, (type-10)%12*31, int((type-10)/12)*31);
    }
}





Bonuses::Bonuses()
{
  for (int t=0; t<5 ;t++)
    bo[t].type = -1;
}



Bonuses::~Bonuses()
{
}



int Bonuses::Add(int x, int y,int type)
{
  int t=0;
  while (bo[t].type != -1 && t<5)
    t++;
  if (t == 10)
    return -1;

  bo[t].type = type;
  bo[t].x = bo[t].oldx = x;
  bo[t].y = bo[t].oldy =y;
  bo[t].next = y;
  bo[t].speed = 4;
  return 0;
}
  


void Bonuses::Update()
{
  for (int t = 0;t < 5;t++)
    if (bo[t].type > -1)
      {
	bo[t].Update();
      }
}      


void Bonuses:: DeleteAll()
{
  for (int t=0; t<5 ;t++)
    if ( bo[t].type != -1)
      {
	bo[t].type = -1;
	//pw_rop((Xv_opaque)pw, bo[t].x, bo[t].y, BRICK_WIDTH,BRICK_HEIGHT, 
	//       PIX_SRC, poBack.pr, bo[t].x,bo[t].y);
      }
}







