#define NUMBER_OF_PIXELS 70


#ifndef _effect_hh_
#define _effect_hh_

#include "global.hh"

class Effect
{
  public:

  char** text;
  int x;
  int y;
  int height;
  int width;
  int row;
  int co;
  int rows;
  int startgr;
  int degx[NUMBER_OF_PIXELS];
  int degy[NUMBER_OF_PIXELS];
  int deg;
  int size;
  Pixobj poButtons,poKo,poKeso,poBest,poNed;;
  Effect();
  ~Effect();

  inline void ShowXY(const Pixobj &p, int x, int y, int op = PIX_SRC) 
    {  pw_rop((Xv_opaque)pw, x, y, p.pr->pr_size.x, p.pr->pr_size.y,
	      op, p.pr,0,0);   
     }
  
  inline void ShowCentered(const Pixobj &p, int op = PIX_SRC)
    { 
      pw_rop((Xv_opaque)pw, (GAME_WIDTH*BRICK_WIDTH-p.pr->pr_size.x)/2, (GAME_HEIGHT*BRICK_HEIGHT-p.pr->pr_size.y)/2, p.pr->pr_size.x, p.pr->pr_size.y,
	     op, p.pr,0,0);   
    }
  
  void ArlaIn();
  void PutBat();
  void Intro();
  void PanelUp();
  void LevelIn();
  void FadeOut(int x1=0,int y1=0,int x2=GAME_WIDTH*BRICK_WIDTH,
	       int y2=(GAME_HEIGHT+2)*BRICK_HEIGHT);
  void UpdateScore();
  void UpdateLife();
  void UpdateTime(int n);
  void PrintText(char* text ,Pixobj &pix ,int x ,int y, int space = 0, int op = PIX_SRC|PIX_DST);
  void PrintWinText(char* text ,int x ,int y, int space = 0,
		    int mode=PIX_SRC|PIX_DST);
  void PrintSpecialText(char* text ,int x ,int y, int space = 0);
  void UpdateLetters();
  void InitScroll(char** te,int srows,int sx,int sy, int swidth, int sheight);
  void ScrollUp(int speed);
  void ScrollDown(int speed);
  void ScrollFullDown(int speed);
  void ViewHiscoreList();
  int GetLetter(int b);
  void InitMainMenu();
  void InitGlobe(int gsize);
  void SpinGlobe(int x,int y);
};

#endif
