
#ifndef _declarations_hh_
#define _declarations_hh_


#include "pixobj.hh"
#include <pixrect/pr_io.h>
#include <xview/xview.h>
#include <xview/pixwin.h>
#include <xview/xv_xrect.h>
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/notice.h>
#include "led_ui.h"
#include <pwd.h>
#include "level.hh"
#include "brick.hh"

#define GAME_WIDTH 13
#define GAME_HEIGHT 23
#define BRICK_WIDTH 58
#define BRICK_HEIGHT 28
#define MARK_WIDTH 63
#define MARK_HEIGHT 36
#define SELECTED xv_get(Led_win_main.list_world, PANEL_LIST_FIRST_SELECTED)
#define NROWS xv_get(Led_win_main.list_world, PANEL_LIST_NROWS)
#define SELECT(n) xv_set(Led_win_main.list_world, PANEL_LIST_SELECT, n, TRUE, NULL)

enum position { before, after, top, bottom };

led_win_main_objects	Led_win_main;
led_win_edit_objects	Led_win_edit;
led_win_bricks_objects	Led_win_bricks;
led_win_level_objects	Led_win_level;
led_win_world_objects	Led_win_world;
led_win_props_objects	Led_win_props;

/* PROTOTYPES */

void DrawLevel();
void Draw(int x,int y,int br);
void MarkBrick(int br,int op);
void ClearList();

void GetLevelProperties();
void SetLevelProperties();
void SetWorldProperties();

void SetLevels();


void InsertLevel(position pos);
void DisableMenuItem(Panel_item item, char *n);
void EnableMenuItem(Panel_item item, char *n);
void GlobalSelectCheck();
void InsertOrder(uchar a, uchar n);
void DeleteOrder(uchar n);
void InitBackground(int n);

/* DECLARATIONS */

uchar brick[13*23];
uchar *order = new uchar[255];
char rasdir[255];
char filename[255];
World *world;
Level *level;
Pixwin *ewin;
Pixwin *bwin;
Pixwin *pwin;
Pixobj bricks;
Pixobj mask;
Brick brix[100];
struct properties props;
uchar cur;	// current level
int mark[4];
char tmp[255];

extern int edited;
extern Pixobj back;

inline Message(Frame frame, char *n, int b = 0) 
{ if (b)
    fprintf(stderr, "%c", '\007');
  xv_set(frame, FRAME_LEFT_FOOTER, n, NULL);
}

inline void Set(Xv_opaque xvo, char *n)
{
  xv_set(xvo, PANEL_VALUE, n, NULL);
}

inline void Set(Xv_opaque xvo, int n)
{
  xv_set(xvo, PANEL_VALUE, n, NULL);
}

inline int Get(char *n, Xv_opaque xvo)
{
  if (n == NULL)
    return (int)xv_get(xvo, PANEL_VALUE);
  strcpy(n, (char*)xv_get(xvo, PANEL_VALUE));
  return 0;
}


#endif

