/*

   Source  : Arlanoid Level Editor
   Date    : 950219
   Authors : Danster/Bepp of Team Keso

*/

#include <pwd.h>
#include "declarations.hh"
#include <X11/Xatom.h>

//Notify_value frame_interpose(Frame, Event, Notify_arg, Notify_event_type);


char *friends[] = { "pt93jr", "pt93da", "pt94jan",
		    "di92th", "pt94mda","pt93pw",
		    NULL };

Pixobj back(GAME_WIDTH*BRICK_WIDTH, GAME_HEIGHT*BRICK_HEIGHT, 1);
uchar cur= 0;	// current level
int edited = 0;

#ifdef MAIN

Attr_attribute	INSTANCE;

int main(int argc, char **argv)
{
  struct passwd *P = getpwuid(getuid());
  for (int k = 0, m = 0; friends[k] != NULL; k++)
    if (!strcmp(friends[k], P->pw_name)) m = 1;
  
  if (m == 0) exit(0);

  xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);
  INSTANCE = xv_unique_key();
  
  Led_win_main.objects_initialize(NULL);
  Led_win_edit.objects_initialize(Led_win_main.win_main);
  Led_win_bricks.objects_initialize(Led_win_main.win_main);
  Led_win_props.objects_initialize(Led_win_bricks.win_bricks);
  Led_win_level.objects_initialize(Led_win_main.win_main);
  Led_win_world.objects_initialize(Led_win_main.win_main);

//  (void)notify_interpose_event_func(Led_win_main.win_main, frame_interpose, NOTIFY_SAFE);

  xv_set(Led_win_main.win_main, XV_X, 0, XV_Y, 20, NULL);
  xv_set(Led_win_edit.win_edit, XV_X, 1142-GAME_WIDTH*BRICK_WIDTH, XV_Y, 0, NULL);
  xv_set(Led_win_bricks.win_bricks, XV_X, 0, XV_Y, 270, NULL);
  xv_set(Led_win_main.btn_next, PANEL_INACTIVE, FALSE, NULL);

  ewin = canvas_pixwin(Led_win_edit.ecanvas);
  bwin = canvas_pixwin(Led_win_bricks.bcanvas);
  pwin = canvas_pixwin(Led_win_props.pcanvas);

  bricks.Load("gfx/bricks.ras");
  mask.Load("gfx/mask.ras");
  strcpy(rasdir, "/home/jupiter/pt/pt93/pt93da/KESO/SRC/ARLANOID/gfx/patterns");
  Message(Led_win_main.win_main, "Welcome to Arlanoid Level editor!");
  
  brix->LoadBricks(brix);

  mark[1] = 0;
  mark[2] = 0;
  mark[3] = 0;

  filename[0] = '\0';

  Display* dpy = (Display*) xv_get(Led_win_main.win_main, XV_DISPLAY);

  xv_main_loop(Led_win_main.win_main);
  exit(0);
}

#endif


void GetLevelProperties()
{
  Get(props.n, Led_win_level.txt_level_name);
  Get(props.a, Led_win_level.txt_level_author);
  Get(props.c, Led_win_level.txt_level_comment);
  Get(props.b, Led_win_level.txt_level_background);
  props.f[0] = Get(NULL, Led_win_level.slider_level_time);
  props.f[1] = Get(NULL, Led_win_level.slider_level_increase);
  props.f[2] = Get(NULL, Led_win_level.slider_level_speed);
  props.f[3] = Get(NULL, Led_win_level.setting_alignment);
}


void SetLevelProperties()
{
  sprintf(tmp, "%s by %s", props.n, props.a);
  xv_set(Led_win_edit.win_edit, XV_LABEL, tmp, NULL);
  Set(Led_win_level.txt_level_name, props.n);
  Set(Led_win_level.txt_level_name, props.n);
  Set(Led_win_level.txt_level_author, props.a);
  Set(Led_win_level.txt_level_comment, props.c);
  Set(Led_win_level.txt_level_background, props.b);

  Set(Led_win_level.slider_level_time, props.f[0]);
  Set(Led_win_level.slider_level_increase, props.f[1]);
  Set(Led_win_level.slider_level_speed, props.f[2]);
  Set(Led_win_level.setting_alignment, props.f[3]);
}

void SetBrickProperties(int n)
{
  Set(Led_win_props.txt_brick_name, brix[n].name);

  Set(Led_win_props.txt_brick_name, brix[n].name);
  Set(Led_win_props.txt_brick_sound, brix[n].sound);
  Set(Led_win_props.txt_brick_bonus, brix[n].bonus);
  Set(Led_win_props.txt_brick_breakable, brix[n].strength);
  Set(Led_win_props.txt_brick_change_to, brix[n].changeTo);
  Set(Led_win_props.txt_brick_special, brix[n].special);
  Set(Led_win_props.txt_brick_score, brix[n].score);
  Set(Led_win_props.txt_brick_needed, brix[n].needed);
  Set(Led_win_props.txt_brick_explosion, brix[n].explosion);
  Set(Led_win_props.txt_brick_mask, brix[n].mask);
}

// Set txtfields from world properties

void SetWorldProperties()
{
  world->GetProperties(&props);
  Set(Led_win_world.txt_world_name, props.n);
  Set(Led_win_world.txt_world_author, props.a);
  Set(Led_win_world.txt_world_comment, props.c);
}


void SetLevels()
{
  xv_set(Led_win_main.msg_levels, PANEL_INACTIVE, FALSE, NULL);
  sprintf(tmp, "Level: %d/%d", SELECTED+1, world->Levels());
  xv_set(Led_win_main.msg_levels, PANEL_LABEL_STRING, tmp, NULL);
}

// Add level to list

void InsertLevel(position pos)
{
  uchar n, a;

  delete level;
  level = new Level;
  a = world->InsertLevel(*level);
  cur = SELECTED;
  if (SELECTED == -1) cur = 0;
  world->LevelCopy(brick, a);

  switch (pos)
  {
  case before:
    n = cur;
    break;

  case after:
    n = cur+1;
    break;

  case top:
    n = 0;
    break;

  case bottom: // ok
    n = NROWS;
    break;
  }

  InsertOrder(a, n);
  level->GetProperties(&props);
//  world->LevelCopy(brick, order[n]);
  
  // Screen

  SetLevelProperties();
  SetLevels();

  xv_set(Led_win_main.list_world, PANEL_LIST_INSERT, n, PANEL_LIST_STRING, n, props.n, NULL);
  SELECT(n);
  InitBackground(order[n]);

  if (NROWS > 1)
    EnableMenuItem(Led_win_main.btn_level, "Move");
  else
  {
    EnableMenuItem(Led_win_main.btn_level, "Properties");
    DisableMenuItem(Led_win_main.btn_level, "Move");
    EnableMenuItem(Led_win_main.btn_level, "Delete");
    xv_set(Led_win_main.btn_open, PANEL_INACTIVE, FALSE, NULL);
  }
  
  if (xv_get(Led_win_edit.win_edit, XV_SHOW) == TRUE)
  {
    world->LevelCopy(brick, n);
    DrawLevel();
    strcpy(tmp, props.n); 
    strcat(tmp, " by "); 
    strcat(tmp, props.a);
    xv_set(Led_win_edit.win_edit, XV_LABEL, tmp, NULL);
  }

  if (xv_get(Led_win_edit.win_edit, XV_SHOW) == TRUE)
    xv_set(Led_win_main.btn_open, PANEL_INACTIVE, TRUE, NULL);

  if (SELECTED < NROWS-1)
    xv_set(Led_win_main.btn_next, PANEL_INACTIVE, FALSE, NULL);
  strcpy(tmp, "Level '");
  strcat(tmp, props.n);
  strcat(tmp, "' inserted ok."); 
  Message(Led_win_main.win_main, tmp);
  edited = 1;
//  world->DumpAll(0);
}

void InitBackground(int n)
{
  int m = xv_get(Led_win_level.setting_alignment, PANEL_VALUE);
  Pixobj pobj(GAME_WIDTH*BRICK_WIDTH, GAME_HEIGHT*BRICK_HEIGHT, 1);
  back = PIX_CLR;

  world->GetLevelProperties(n, &props);

  if (strlen(props.b) > 0)
  {
    if (!pobj.Load(props.b))
    {
      if (props.f[3] == 0)
	back.Op(PIX_SRC).Rect((GAME_WIDTH*BRICK_WIDTH-pobj.prWidth())/2, 
			      (GAME_HEIGHT*BRICK_HEIGHT-pobj.prHeight())/2, 
			      pobj.prWidth(), pobj.prHeight()) = pobj.X(0).Y(0);
      if (props.f[3] == 1)
	back.Op(PIX_SRC).Rect(0, 0, back.prWidth(), back.prHeight())
	  *= pobj.X(0).Y(0);
    }
    else
      Message(Led_win_level.win_level, "Error loading rasterfile.", 1);
  }
}
    

void DrawLevel()
{
  int x, y;
  pw_rop((Xv_opaque)ewin, 0, 0, back.prWidth(), back.prHeight(), PIX_SRC, back.pr, 0, 0);

  for (x = 0; x < GAME_WIDTH; x++)
    for (y = 0; y < GAME_HEIGHT; y++)
    {
      if (brick[y*GAME_WIDTH+x]!=0)
      {
	int br = brick[y*GAME_WIDTH+x];
	if (brix[br].mask > -1) // maska
	{
	  pw_rop((Xv_opaque)ewin, 
		 x*BRICK_WIDTH,
		 y*BRICK_HEIGHT,
		 BRICK_WIDTH, BRICK_HEIGHT, 
		 PIX_SRC,
		 back.pr,
		 x*BRICK_WIDTH,
		 y*BRICK_HEIGHT);
	  
	  pw_rop((Xv_opaque)ewin, 
		 x*BRICK_WIDTH, 
		 y*BRICK_HEIGHT,
		 BRICK_WIDTH, BRICK_HEIGHT, 
		 PIX_SRC&PIX_DST,
		 mask.pr,
		 (brix[br].mask%10)*BRICK_WIDTH,
		 int(brix[br].mask/10)*BRICK_HEIGHT);
	  
	  pw_rop((Xv_opaque)ewin, 
		 x*BRICK_WIDTH, 
		 y*BRICK_HEIGHT,
		 BRICK_WIDTH, BRICK_HEIGHT, 
		 PIX_SRC|PIX_DST,
		 bricks.pr,
		 (br%10)*BRICK_WIDTH,
		 int(br/10)*BRICK_HEIGHT);
	}
	else // normal
	pw_rop((Xv_opaque)ewin, x*BRICK_WIDTH, y*BRICK_HEIGHT,
	       BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	       bricks.pr, brick[y*GAME_WIDTH+x]%10*BRICK_WIDTH,
	       int(brick[y*GAME_WIDTH+x]/10)*BRICK_HEIGHT);
      }
    }
}


void Draw(int x,int y,int br)
{
  if (y >= BRICK_HEIGHT*GAME_HEIGHT)
    return; // inte g ver sista raden
  
  if ((x >= BRICK_WIDTH) && (x <= BRICK_WIDTH*(GAME_WIDTH-1)) && (y >= BRICK_HEIGHT*(GAME_HEIGHT-2)))
    return; // inte g ver height-2 om innanfr mur

  if (((x <= BRICK_WIDTH) 
       || (x >= BRICK_WIDTH*(GAME_WIDTH-1))) 
      && (brix[br].strength != 5))
    return; // mur kan rita till game height

  if ((brix[br].strength != 5) 
       && ((y <= BRICK_HEIGHT) 
	   || (x <= BRICK_WIDTH) 
	   || (x >= BRICK_WIDTH*(GAME_WIDTH-1))))
      return; // ingen annan n mur skall kunna rita p vggarna

  if (br !=0 )
  {
    if (brix[br].mask > -1) // maska
    {
      pw_rop((Xv_opaque)ewin, int(x/BRICK_WIDTH)*BRICK_WIDTH,
	     int(y/BRICK_HEIGHT)*BRICK_HEIGHT,
	     BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	     back.pr,int(x/BRICK_WIDTH)*BRICK_WIDTH,
	     int(y/BRICK_HEIGHT)*BRICK_HEIGHT);

      pw_rop((Xv_opaque)ewin, int(x/BRICK_WIDTH)*BRICK_WIDTH, 
	     int(y/BRICK_HEIGHT)*BRICK_HEIGHT,
	     BRICK_WIDTH, BRICK_HEIGHT, 
	     PIX_SRC&PIX_DST,
	     mask.pr,
	     (brix[br].mask%10)*BRICK_WIDTH,
	     int(brix[br].mask/10)*BRICK_HEIGHT);
	     
      pw_rop((Xv_opaque)ewin, int(x/BRICK_WIDTH)*BRICK_WIDTH, 
	     int(y/BRICK_HEIGHT)*BRICK_HEIGHT,
	     BRICK_WIDTH, BRICK_HEIGHT, 
	     PIX_SRC|PIX_DST,
	     bricks.pr,
	     (br%10)*BRICK_WIDTH, int(br/10)*BRICK_HEIGHT);
    }
    else // ej maska
      pw_rop((Xv_opaque)ewin, int(x/BRICK_WIDTH)*BRICK_WIDTH,
	     int(y/BRICK_HEIGHT)*BRICK_HEIGHT,
	     BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	     bricks.pr,
	     (br%10)*BRICK_WIDTH,
	     (br/10)*BRICK_HEIGHT);
  }
  else // nollan
  {
    pw_rop((Xv_opaque)ewin, int(x/BRICK_WIDTH)*BRICK_WIDTH,
	   int(y/BRICK_HEIGHT)*BRICK_HEIGHT,
	   BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC,
	   back.pr,int(x/BRICK_WIDTH)*BRICK_WIDTH,
	   int(y/BRICK_HEIGHT)*BRICK_HEIGHT);
	  
  }
  brick[int(y/BRICK_HEIGHT)*GAME_WIDTH+int(x/BRICK_WIDTH)] = br;
  edited = 1;
}

void MarkBrick(int br,int op)
{
  int x = 4+(br%6)*MARK_WIDTH;
  int y = int((br/6))*MARK_HEIGHT;

  // Uppe
  pw_vector((Xv_opaque)bwin, x-4, y, x+MARK_WIDTH-5, y, op, 0);
  pw_vector((Xv_opaque)bwin, x-4, y-1, x+MARK_WIDTH-5, y-1, op, 0);

  // Under
  pw_vector((Xv_opaque)bwin, x-2, y+MARK_HEIGHT-4, x+MARK_WIDTH-5,
	    y+MARK_HEIGHT-4, op, 0);
  pw_vector((Xv_opaque)bwin, x-2, y+MARK_HEIGHT-5, x+MARK_WIDTH-5,
	    y+MARK_HEIGHT-5, op, 0);

  // Vnster
  pw_vector((Xv_opaque)bwin, x-3, y, x-3, y+MARK_HEIGHT-5, op,0);
  pw_vector((Xv_opaque)bwin, x-4, y, x-4, y+MARK_HEIGHT-5, op,0);

  // Hger
  pw_vector((Xv_opaque)bwin, x+MARK_WIDTH-4, y, x+MARK_WIDTH-4,
	    y+MARK_HEIGHT-4, op, 0);
  pw_vector((Xv_opaque)bwin, x+MARK_WIDTH-5, y, x+MARK_WIDTH-5,
	    y+MARK_HEIGHT-4, op, 0);
}

void InsertOrder(uchar a, uchar n)
{
  uchar tmp[255];
  memcpy(tmp, order, n);
  tmp[n] = a;

  for (int i = n; i < world->Levels()-1; i++)
    tmp[i+1] = order[i];

  memcpy(order, tmp, world->Levels());
}

void DeleteOrder(uchar n)
{
  uchar tmp[255];
  int x = 0, y = 0, t = world->Levels();

  while (y < t)
  {
    if (y != n)
      tmp[x++] = order[y];
    y++;
  }
  memcpy(order, tmp, t-1);
}


void ClearList()
{
  for (int i = NROWS; i >= 0; i--)
  {
    xv_set(Led_win_main.list_world, PANEL_LIST_DELETE, i, NULL);
  }
}

void GlobalSelectCheck()
{
//  printf("GlobalSelectCheck\n");

/*
  Menu_item mi = (Menu_item) xv_find((Menu) xv_get(item, PANEL_ITEM_MENU), MENUITEM, MENU_STRING, n, NULL);
  xv_set(mi, MENU_INACTIVE, FALSE, NULL);

  if (SELECTED == NROWS)
    // disable move down
    else
    // enable move down

  if (SELECTED == 0)
    // disable move up
  else
    // enable move up
*/
}


//
//
// List notify
//
//

int list_world_select(Panel_item item, char *string, Xv_opaque client_data, Panel_list_op op, Event *event, int row)
{
  switch(op) {
  case PANEL_LIST_OP_DESELECT:
    if (SELECTED == -1) SELECT(row);
    world->LevelCopy(order[row], brick);
    break;
    
  case PANEL_LIST_OP_SELECT:
    SetLevels();
    world->GetLevelProperties(order[row], &props);
    InitBackground(order[row]);
    SetLevelProperties();
    world->LevelCopy(brick, order[row]);
    DrawLevel();
    if (row < NROWS-1)
      xv_set(Led_win_main.btn_next, PANEL_INACTIVE, FALSE, NULL);
    else
      xv_set(Led_win_main.btn_next, PANEL_INACTIVE, TRUE, NULL);
    break;
  }
  return XV_OK;
}



Notify_value ctrl_notify(Xv_window win, Event *event, Notify_arg arg, Notify_event_type type)
{
  if ((event_action(event) == ACTION_SELECT) ||
      (event_action(event) == ACTION_ADJUST) ||
      (event_action(event) == ACTION_MENU))
  {
    Message(Led_win_main.win_main, (char*)NULL);
  }

  return notify_next_event_func(win, (Notify_event) event, arg, type);
}

Panel_setting brick_change_to_notify(Panel_item item, Event *event)
{
  int	value = (int) xv_get(item, PANEL_VALUE);
  pw_rop((Xv_opaque)pwin, 5, 5+BRICK_HEIGHT+10, BRICK_WIDTH, BRICK_HEIGHT, PIX_SRC, bricks.pr, brix[value].x, brix[value].y);
  return panel_text_notify(item, event);
}

Notify_value frame_interpose(Frame frame, Event *event, Notify_arg arg, Notify_event_type type)
{
  Notify_value n = notify_next_event_func(frame, event, arg, type);
  printf("%s\n", (int)window_get(frame, FRAME_CLOSED)>0?"Closed":"Open");
  return n;
}

//
//
//
//
//
//
//
//

